// Program to rename a file to the day of the year number extension.
// Default is to provide today's date.  Later versions can optionally
// use the file creation date.  Copyright 1991, 92  Fred R. Niemczenia.

#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>

int main  ( int argc, char *argv[] )
{   struct ffblk  ffblk;
    int day, num_args, done;
    char file_ext[4], len, *pos, *start;
    char pathspec [MAXPATH], newspec [MAXPATH]= {'\0'};

    day= day_of_year ();
    sprintf ( file_ext, "%03d", day);

    num_args= argc;
    if  ( num_args != 2 )
    {  puts ("");
       puts (" Program YEARDAY converts a file extension to the day number");
       puts (" of the year.  Just supply the pathspec (of the file) on the");
       puts (" command line as:  YEARDAY D:\\pathspec\\filename.ext");
       printf (" Copyright 1991 by Fred R. Niemczenia.  [%d]\n", day);
       return 1;
    }

    strcpy ( pathspec, argv[1] );              /* Get the command line */
    done=  findfirst ( pathspec, &ffblk, 0 );  /* Test if file exists  */
    if  ( done != 0 )
    {  puts ("");
       puts (" YEARDAY was unable to find the file given on the command");
       puts (" line, or there was more than one filename given.");
       return 2;
    }

    pos= strchr ( pathspec, '.');
    if  ( pos )
    {   start= pathspec;
        len= pos - start + 1;
        strncat (newspec, pathspec, len);
        strcat (newspec, file_ext);
    }
    else
    {   strcpy (newspec, pathspec);
        strcat (newspec, ".");
        strcat (newspec, file_ext);
    }
    rename (pathspec, newspec);
    printf ("\n Renamed  %s  to  %s\n", pathspec, newspec);

    return 0;
}



int  day_of_year ()
{   struct date d;
    int i, day, daymon [13]= {0,31,28,31,30,31,30,31,31,30,31,30,31};
    getdate ( &d );
    day= 0;
    for   ( i=0; i < d.da_mon; i++ )   day= day + daymon[i];
    day= day + d.da_day;
    if  ( d.da_year /4 *4  ==  d.da_year  &&  (( d.da_year /400 * 400 ==
          d.da_year )  ^  ( d.da_year /100 * 100 != d.da_year )) )
    {   if  ( d.da_mon > 2 )  day= day + 1;
    }

    return day;
}




